﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FormsNotifier
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            NotificationManager.ReceiveAlertUpdates += new NotificationManager.ReceiveAlerts<MyAlertData>(AlertEventReceived);
        }

        private void cmdGenerate_Click(object sender, EventArgs e)
        {
            System.Threading.ThreadPool.QueueUserWorkItem(new System.Threading.WaitCallback(SimulateTemperatures));
        }

        public void SimulateTemperatures(Object o)
        {
            Random rand = new Random(14);
            for (int i = 0; i < 25; i++)
            {
                int temp = rand.Next(2, 19);
                System.Threading.Thread.Sleep(500);
                NotificationManager.Notify(new MyAlertData() { City = "NewYork", Temperature = temp, AlertTime = DateTime.Now });
            }
        }

        private void AlertEventReceived(MyAlertData alert)
        {
            String strdata = alert.ToString();
            Invoke((MethodInvoker)delegate { txtReceivedEvents.AppendText(strdata); });
        }
    }
}
